

(define coroutine (lambda (f)   ; f = (lambda (resume) (lambda (arg) E))
   (call/cc (lambda (LCS)
      (let ((switch (lambda (c k v)
                       (set! LCS k)
                       (c v))))
         (let ((resumer (lambda (v)
                           (call/cc (lambda (k)
                              (switch LCS k v))))))
            (switch LCS (f resumer) resumer)))))))


(define fringer (lambda (tree) (lambda (resume) (lambda (EOT)
   (letrec ((car-fringe
              (lambda (tree)
                      (if (atom? tree)
                          (resume  tree)
                          (begin (car-fringe (car tree))
                                 (cdr-fringe (cdr tree))))))
            (cdr-fringe
              (lambda (tree)
                      (cond ((null? tree) EOT)
                            ((atom? tree) 
                             (resume tree))
                            (t (car-fringe (car tree))
                               (cdr-fringe (cdr tree)))))))
           (resume (car-fringe tree)))))))


(define samefringe2 (lambda (tree1 tree2)
   (let ((co1 (coroutine (fringer tree1)))
         (co2 (coroutine (fringer tree2)))
         (eot (cons nil nil)))
      (letrec ((compare (lambda (l1 l2)
                  (if (eq? l1 l2)
                      (if (atom? l1)
                          (compare (co1 eot)
                                   (co2 eot))
                          t)
                      nil))))
           (compare (co1 eot)
                    (co2 eot))))))

(define father-samefringe (lambda (trees)
   (if (null? trees) 
       nil
       (let ((co-list (letrec ((genco (lambda (trees)
                                  (if (null? trees)
                                      nil
                                      (cons (coroutine (fringer (car trees)))
                                            (genco (cdr trees)))))))
                              (genco trees)))
             (eot (cons nil nil)))
            (letrec ((compare (lambda () 
                       (letrec ((compare* (lambda (v1 cos)
                                   (if (null? cos)
                                       (if (eq? v1 eot) 
                                           t
                                           (compare))
                                       (if (eq? v1 ((car cos) eot))
                                           (compare* v1 (cdr cos))
                                           nil)))))
                               (compare* ((car co-list) eot)
                                         (cdr co-list))))))
                    (compare))))))


(define brother-samefringe (lambda (trees)
   (call/cc (lambda (done)
       (let ((eot (cons nil nil)))
          (let ((co (letrec
                      ((gencos (lambda (trees)
                              (if (null? (cdr trees))   
                                  (coroutine (fringer (car trees)))
                                  (let ((co (gencos (cdr trees))))
                                       (coroutine
                                         (lambda (resume)
                                           ((fringer (car trees))
                                            (lambda (v) 
                                               (if (eq? (co eot) v)
                                                   (resume v)
                                                   (done nil)))))))))))
                      (gencos trees))))
               (letrec ((compare (lambda ()  
                                    (if (eq? (co eot) eot)
                                        t
                                        (compare)))))
                       (compare))))))))


                                          
(define a1 '((((w)))))
(define a2 '(w))
(define a3 'w)

(define b1 '((a b . c) (((e f)) d)))
(define b2 '((a) ((((b) c)) e) f . d))
(define b3 '((((((((a) b) c) e) f) d))))

(define f1 '((((a b c) ) (e f f))))
(define f2 '((((((((a (b (c e) f) d) r))))))))

