(function-alias 'editexpr 'edite)

(add-to-syntax-table '(edit)
   (lambda (l) (set-car! (cdr l) (intern* (cadr l)))
      (list (lambda (name c)
	       ((lambda (e)
		   (if (assq name (fluid defined-forms))
		       (execute (compile (save-defining-form e)))
		       (execute
			  (compile
			     (list (quote set!)
				   name
				   (list (quote quote) e)))))
		   name)
		(editexpr (copy c) nil nil)))
	    (list 'quote (cadr l))
	    ((lambda (v)
		(if v
		   ((lambda (f)
		       (list (quote quote) (cdr f))) v)
		   (begin (if (or (constant? (cadr l))
				  (function? (global-binding (cadr l))))
			      (begin (print "[edit error: ")
				     (print (cadr l))
				     (print " not editable]")
				     (newline)
				     (reset))
			      (cadr l)))))
	     (assq (cadr l) (fluid defined-forms))))))

(remove-from-namespace 'editexpr)
